#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <qwidget.h>
#include <qpushbt.h>
#include <qevent.h>
#include <iostream.h>
#include <kmsgbox.h>
#include <kmenubar.h>

typedef struct
{
 int steine[2];
 int spielsteine[2];
 int muehlestatus;
 int board[3][3][3];
 int activeplayer;
} gamestate;

class knine : public QWidget
{
    Q_OBJECT
private:
    int gbp_id,gbc_id,tb_id,ss_id,ds_id,ls_id;
    int p1c_id,p2c_id;
    int p1c,p2c;
    int l1_id,l2_id,l3_id;

    int distx,disty,linewx,linewy;
    int markposx,markposy;
    int activefeld;
    char playername[2][20];
    int gameactive;
    gamestate g;

    KMsgBox * winwidget;

        
    QPixmap pixmap_red;
    QPixmap pixmap_yellow;
    QPixmap pixmap_blue;
public:
    knine(QWidget * parent = 0, const char * name = 0);
    ~knine();
    int checkmuehle(gamestate h,int feld);
    int isallowed(gamestate h,int feld);
    int remove_stone(gamestate &h,int feld,int silent);
    int set_stone(gamestate &h,int feld,int silent);
    int move_stone(gamestate &h,int feldold,int feldnew,int silent);
    void play_comp();
    int getscore(gamestate h);
    void next_player(gamestate h);

    KMenuBar * menu;
    QPopupMenu * filemenu;
    QPopupMenu * optionsmenu;
    QPopupMenu * movemenu;
    QPopupMenu * levelmenu;

    int sublevel, prev_sublevel;
    void initBoard();
    void rowClicked(int);
protected:
    void paintEvent(QPaintEvent *);
    void mousePressEvent(QMouseEvent *);
    void resizeEvent(QResizeEvent *);
public slots:
    void newGame();
    void fileQuit();
    void player1Comp();
    void defaultSize();
    void gameBoardPixmap();
    void gameBoardColor();
    void largeSize();
    void player2Comp();
    void smallSize();
    void takeBack();
    void level1();
    void level2();
    void level3();
};

#endif
